<?php

/**
* Copyright (C) 2005 Grummfy
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
* Class permetant le traitement de l'authentification par http request
*
* @author Grummfy <grummfy@yahoo.fr>
* @copyright Grummfy 05/12/2005
* @link  http://www.grummfy.com Grummfy
* @version 1.0.0
* @package auth_http
* @license http://www.gnu.org/licenses/lgpl.html LGPL (GNU Lesser General Public License)
*/
class auth_http
{
	/**
	* Pseudonyme retir du header
	*
	* Pseudonyme retir du header
	* Aucun addslashes ou autre n'est effetu
	*
	* @var string
	*/
	var $login;

	/**
	* Mot de passe retir du header
	*
	* Mot de passe retir du header
	* Aucun addslashes ou autre n'est effetu
	*
	* @var string
	*/
	var $password;

	/**
	* Code d'erreur en cas de problme
	*
	* Code d'erreur en cas de problme
	* -1 :: aucune erreur
	* 0 :: le header  dj t envoy
	* 1 :: pas de login, ni de password
	*
	* @var int
	*/
	var $error;

	/**
	* Renvoi true ou false suivant qu'il y ai un login/password ou pas
	*
	* @param string messages message envoyer par le herder pour l'authentification
	* @return bool true si on rcure le password et le login
	*/
	function http_auth($messages)
	{
		$this->reset();
		// on test bien que le header n'as pas encore t envoy
		if (!headers_sent())
		{
			// on test si $PHP_AUTH_USER ou si $PHP_AUTH_PW  t envoyer, et s'il contient quelque chose.
			if (!isset($GLOBALS['_SERVER']['PHP_AUTH_USER']) && !isset($GLOBALS['_SERVER']['PHP_AUTH_PW']))
			{
				// il est vide
				header('WWW-Authenticate: Basic realm="' . $messages . '"');
				header('HTTP/1.0 401 Unauthorized');
				$this->error = 1;
				return false;
			}
			elseif (isset($GLOBALS['_SERVER']['PHP_AUTH_USER']) && isset($GLOBALS['_SERVER']['PHP_AUTH_PW']))
			{
				// on stock le login et le password
				$this->login = $GLOBALS['_SERVER']['PHP_AUTH_USER'];
				$this->password = $GLOBALS['_SERVER']['PHP_AUTH_PW'];
				return true;
			}
		}
		echo $GLOBAL['_SERVER']['PHP_AUTH_PW'];
		$this->error = 0;
		return false;
	}

	/**
	* On retourne le numro d'erreur
	*
	* @return int code d'erreur
	*/
	function get_error()
	{
		return $this->error;
	}

	/**
	* remet les variable  0
	*/
	function reset()
	{
		$this->error = -1;
		$this->login = '';
		$this->password = '';
	}

	/**
	* Retourne les identifiants trouv
	*
	* @return array 0 -> login, 1-> password
	*/
	function get_identifiers()
	{
		return array($this->login, $this->password);
	}
	
}

?>